//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----
#property indicator_chart_window
#property indicator_buffers    6
#property indicator_color1     DeepSkyBlue
#property indicator_color2     DeepSkyBlue
#property indicator_color3     OrangeRed
#property indicator_color4     OrangeRed
#property indicator_color5     DimGray
#property indicator_color6     DimGray
#property indicator_width1     2
#property indicator_width4     2
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property indicator_style5     STYLE_DOT
#property indicator_style6     STYLE_DOT

//
//
//
//
//

extern int    HlbPeriod          = 5;
extern int    HlbTimeFrame       = PERIOD_D1;
extern int    HlbTimeFrameShift  = 1;
extern double HlbRangeMultiplier = 1.0;

//
//
//
//
//

double hlbHi0[];
double hlbHi1[];
double hlbHi2[];
double hlbLo0[];
double hlbLo1[];
double hlbLo2[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, hlbHi2); 
   SetIndexBuffer(1, hlbHi1); 
   SetIndexBuffer(2, hlbLo1); 
   SetIndexBuffer(3, hlbLo2); 
   SetIndexBuffer(4, hlbHi0); 
   SetIndexBuffer(5, hlbLo0); 
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double sumhi = 0;
      double sumlo = 0;
      double sumrh = 0;
      double sumrl = 0;
      
         //
         //
         //
         //
         //
         
         int y = iBarShift(NULL,HlbTimeFrame,Time[i]);
            for (int k=0; k<HlbPeriod; k++)
            {
               sumhi += iHigh(NULL,HlbTimeFrame,y+k+HlbTimeFrameShift);
               sumlo += iLow (NULL,HlbTimeFrame,y+k+HlbTimeFrameShift);
               sumrh += HlbRangeMultiplier*MathAbs(iHigh(NULL,HlbTimeFrame,y+k+HlbTimeFrameShift)-iHigh(NULL,HlbTimeFrame,y+k+HlbTimeFrameShift+1));
               sumrl += HlbRangeMultiplier*MathAbs(iLow (NULL,HlbTimeFrame,y+k+HlbTimeFrameShift)-iLow (NULL,HlbTimeFrame,y+k+HlbTimeFrameShift+1));
            }
         sumhi /= HlbPeriod;
         sumlo /= HlbPeriod;
         sumrh /= HlbPeriod;
         sumrl /= HlbPeriod;
            
         //        
         //
         //
         //
         //

      hlbHi0[i] = sumhi;
      hlbLo0[i] = sumlo;
      hlbHi2[i] = sumhi+sumrh;
      hlbHi1[i] = sumhi-sumrh;
      hlbLo1[i] = sumlo+sumrl;
      hlbLo2[i] = sumlo-sumrl;
   }
   return(0);
}